<?php

require_once(dirname(__FILE__) . '/paypal_ja/paypal_ja_definition.php');
require_once(dirname(__FILE__) . '/paypal_ja/paypal_ja_web_payment_plus.php');
require_once(dirname(__FILE__) . '/paypal_ja/paypal_ja_express_checkout.php');
require_once(dirname(__FILE__) . '/paypal_ja/paypal_ja_functions.php');

/*
  $Id: paypal.php,v 1.3 2003/08/12 13:17:09 hawk Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  class paypal_ja {
    var $code, $title, $description, $enabled;
    var $model;

// class constructor
    function paypal_ja() {
      global $order;

      $this->code = 'paypal_ja';
      $this->title = MODULE_PAYMENT_PAYPAL_JA_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_PAYPAL_JA_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_PAYPAL_JA_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_PAYPAL_JA_STATUS == 'True') ? true : false);

//      if ((int)MODULE_PAYMENT_PAYPAL_JA_ORDER_STATUS_ID > 0) {
//        $this->order_status = MODULE_PAYMENT_PAYPAL_JA_ORDER_STATUS_ID;
//      }
      if ((int)MODULE_PAYMENT_PAYPAL_JA_UNCOMMIT_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_PAYPAL_JA_UNCOMMIT_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      if (MODULE_PAYMENT_PAYPAL_JA_SETTLEMENT_TYPE == 'WebPaymentPlus') {
        $this->model = new paypal_ja_web_payment_plus($this->code, $this->title, $this->description, $this->sort_order, $this->enabled);
      } else if (MODULE_PAYMENT_PAYPAL_JA_SETTLEMENT_TYPE == 'ExpressCheckout') {
        $this->model = new paypal_ja_express_checkout($this->code, $this->title, $this->description, $this->sort_order, $this->enabled);
      } else {
        $this->model = NULL;
      }

      if ($this->model != NULL) {
        $this->form_action_url = $this->model->get_form_action_url();
      }
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYPAL_JA_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYPAL_JA_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return $this->model->javascript_validation();
//      return false;
    }

    function selection() {
      return $this->model->selection();
//      return array('id' => $this->code,
//                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return $this->model->pre_confirmation_check();
//      return false;
    }

    function confirmation() {
      return $this->model->confirmation();
//      return false;
    }

    function process_button() {
      return $this->model->process_button();

//      global $order, $currencies, $currency;
//
//      if (MODULE_PAYMENT_PAYPAL_JA_CURRENCY == 'Selected Currency') {
//        $my_currency = $currency;
//      } else {
//        $my_currency = substr(MODULE_PAYMENT_PAYPAL_JA_CURRENCY, 5);
//      }
//      if (!in_array($my_currency, array('CAD', 'EUR', 'GBP', 'JPY', 'USD'))) {
//        $my_currency = 'USD';
//      }
//      $process_button_string = tep_draw_hidden_field('cmd', '_xclick') .
//                               tep_draw_hidden_field('business', MODULE_PAYMENT_PAYPAL_JA_ID) .
//                               tep_draw_hidden_field('item_name', STORE_NAME) .
//                               tep_draw_hidden_field('amount', number_format(($order->info['total'] - $order->info['shipping_cost']) * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency))) .
//                               tep_draw_hidden_field('shipping', number_format($order->info['shipping_cost'] * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency))) .
//                               tep_draw_hidden_field('currency_code', $my_currency) .
//                               tep_draw_hidden_field('return', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL')) .
//                               tep_draw_hidden_field('cancel_return', tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
//
//      return $process_button_string;
    }

    function before_process() {
      return $this->model->before_process();
//      return false;
    }

    function after_process() {
      return $this->model->after_process();
//      return false;
    }

    function output_error() {
      return $this->model->output_error();
//      return false;
    }

    function get_error() {
      return $this->model->get_error();
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYPAL_JA_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
    // for Express Checkout
    define('MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_BUSINESS_ID',        'API桼̾ (ExpressCheckout)');
    define('MODULE_PAYMENT_PAYPAL_JA_EC_DESC_BUSINESS_ID',        'API桼̾ϤƤ');
    define('MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_BUSINESS_PASS',      'APIѥ (ExpressCheckout)');
    define('MODULE_PAYMENT_PAYPAL_JA_EC_DESC_BUSINESS_PASS',      'APIѥɤϤƤ');
    define('MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_BUSINESS_SIGNATURE', 'API̾ (ExpressCheckout)');
    define('MODULE_PAYMENT_PAYPAL_JA_EC_DESC_BUSINESS_SIGNATURE', '嵭ȤAPI̾ꤷƤ');
    define('MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_SETTLEMENT_TYPE',    ' (ExpressCheckout)');
    define('MODULE_PAYMENT_PAYPAL_JA_EC_DESC_SETTLEMENT_TYPE',    'Sale()⤷Authorization(Ϳ)򤷤Ƥ');
    define('MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_CURRENCY',           '̲ (ExpressCheckout)');
    define('MODULE_PAYMENT_PAYPAL_JA_EC_DESC_CURRENCY',           '̲ߤ򤷤Ƥ');
    define('MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_TEST',               'TestĶ (ExpressCheckout)');
    define('MODULE_PAYMENT_PAYPAL_JA_EC_DESC_TEST',               'ƥȻTrueǤʤFalseȤƤ');


      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('PayPal ʧͭˤ', 'MODULE_PAYMENT_PAYPAL_JA_STATUS', 'True', 'PayPal Ǥλʧդޤ?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
//      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('E-Mailɥ쥹', 'MODULE_PAYMENT_PAYPAL_JA_ID', 'you@yourbusiness.com', 'PayPal ӥ˻ѤE-Mailɥ쥹ꤷƲ.', '6', '4', now())");
//      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('̲', 'MODULE_PAYMENT_PAYPAL_JA_CURRENCY', 'Selected Currency', '쥸åȥɽ˻Ѥ̲ߤꤷƲ.', '6', '6', 'tep_cfg_select_option(array(\'Selected Currency\',\'Only USD\',\'Only CAD\',\'Only EUR\',\'Only GBP\',\'Only JPY\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ɽ', 'MODULE_PAYMENT_PAYPAL_JA_SORT_ORDER', '0', 'ɽǤޤۤɾ̤ɽޤ.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Ŭϰ', 'MODULE_PAYMENT_PAYPAL_JA_ZONE', '0', 'Ŭϰ򤹤ȡ򤷤ϰΤߤѲǽȤʤޤ.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");

      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('', 'MODULE_PAYMENT_PAYPAL_JA_SETTLEMENT_TYPE', 'ExpressCheckout', 'פ򤷤Ƥ', '6', '3', 'tep_cfg_select_option(array(\'ExpressCheckout\', \'WebPaymentPlus\'), ', now())");

      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('ʸơ', 'MODULE_PAYMENT_PAYPAL_JA_ORDER_STATUS_ID', '0', 'ꤷơŬѤޤ.', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('ʸ̤ꥹơ', 'MODULE_PAYMENT_PAYPAL_JA_UNCOMMIT_ORDER_STATUS_ID', '0', 'ꤷơPayPalܻŬѤޤ.', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('ƥȴĶ (Sandbox̵ͭ)', 'MODULE_PAYMENT_PAYPAL_JA_WPP_TEST', 'False', 'ƥȻTrueǤʤFalseȤƤ', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PayPal ӥͥȤΡ֥奢ʥޡID', 'MODULE_PAYMENT_PAYPAL_JA_WPP_MERCHANT_ID', '', 'PayPalإ󤷤ơָĿפΥڡ˽񤤤Ƥޤ', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('', 'MODULE_PAYMENT_PAYPAL_JA_WPP_SETTLEMENT_TYPE', 'False', 'ǽǤλʧ(sale)/ǽФͿ(authorization)', '6', '3', 'tep_cfg_select_option(array(\'sale\', \'authorization\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('̲', 'MODULE_PAYMENT_PAYPAL_JA_WPP_CURRENCY', 'Selected Currency', 'ʧ̲ߡ', '6', '6', 'tep_cfg_select_option(array(\'User Selected Currency\',\'USD\',\'JPY\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('顼ȯ᡼륢ɥ쥹', 'MODULE_PAYMENT_PAYPAL_JA_WPP_EMAIL', '', '顼ȯ᡼륢ɥ쥹ϤƤ', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('IPNΤΥȥ졼ͭˤ', 'MODULE_PAYMENT_PAYPAL_JA_WPP_IPN_TRACE_LOG', 'False', 'ȥ졼/tmp/paypal_trance_log.YYYYMMDDե˽Ϥޤ', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ʧˡɲåå', 'MODULE_PAYMENT_PAYPAL_JA_SELECT_MESSAGE', 'ʸλʧ³򤪴ꤤޤ', 'ʧˡ̤ɽɲååϤƤ', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ʸλɲåå', 'MODULE_PAYMENT_PAYPAL_JA_PRE_ORDER_MESSAGE', 'ʲǤʧ³򤪴ꤤޤ', 'ʸλ̤ɽɲååϤƤ', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PayPalȥ󥶥ID', 'MODULE_PAYMENT_PAYPAL_JA_PAYPAL_TXN_ID', 'PayPalμֹ', 'PayPalȥ󥶥ID򼨤åϤƤ', '6', '0', now())");
    // for Express Checkout
    $curencies = array(
      'USER' => '[User Selected Currency]',
      'AUD' => 'Australian Dollar',
      'BRL' => 'Brazilian Real',
      'CAD' => 'Canadian Dollar',
      'CZK' => 'Czech Koruna',
      'DKK' => 'Danish Krone',
      'EUR' => 'Euro',
      'HKD' => 'Hong Kong Dollar',
      'HUF' => 'Hungarian Forint',
      'ILS' => 'Israeli New Sheqel',
      'JPY' => 'Japanese Yen',
      'MYR' => 'Malaysian Ringgit',
      'MXN' => 'Mexican Peso',
      'NOK' => 'Norwegian Krone',
      'NZD' => 'New Zealand Dollar',
      'PHP' => 'Philippine Peso',
      'PLN' => 'Polish Zloty',
      'GBP' => 'Pound Sterling',
      'SGD' => 'Singapore Dollar',
      'SEK' => 'Swedish Krona',
      'CHF' => 'Swiss Franc',
      'TWD' => 'Taiwan New Dollar',
      'THB' => 'Thai Baht',
      'TRY' => 'Turkish Lira',
      'USD' => 'U.S. Dollar',
    );
    $option = array();
    foreach($curencies as $k => $v) {
      $option[] = "array(\'id\' => \'$k\', \'text\' => \'$v\')";
    }
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order,               date_added) values ('".MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_BUSINESS_ID."',        'MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_ID',        '".STORE_OWNER_EMAIL_ADDRESS."', '".MODULE_PAYMENT_PAYPAL_JA_EC_DESC_BUSINESS_ID."',        '6', '11', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order,               date_added) values ('".MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_BUSINESS_PASS."',      'MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_PASS',      '',                              '".MODULE_PAYMENT_PAYPAL_JA_EC_DESC_BUSINESS_PASS."',      '6', '12', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order,               date_added) values ('".MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_BUSINESS_SIGNATURE."', 'MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_SIGNATURE', '',                              '".MODULE_PAYMENT_PAYPAL_JA_EC_DESC_BUSINESS_SIGNATURE."', '6', '13', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('".MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_SETTLEMENT_TYPE."',    'MODULE_PAYMENT_PAYPAL_JA_EC_SETTLEMENT_TYPE',    'Sale',                          '".MODULE_PAYMENT_PAYPAL_JA_EC_DESC_SETTLEMENT_TYPE."',    '6', '14', 'tep_cfg_select_option(array(\'Sale\', \'Authorization\'), ', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('".MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_CURRENCY."',           'MODULE_PAYMENT_PAYPAL_JA_EC_CURRENCY',           'USER',                          '".MODULE_PAYMENT_PAYPAL_JA_EC_DESC_CURRENCY."',           '6', '15', 'tep_cfg_select_option(array(\'".implode("\',\'", array_keys($curencies))."\'), ', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('".MODULE_PAYMENT_PAYPAL_JA_EC_TEXT_TEST."',               'MODULE_PAYMENT_PAYPAL_JA_EC_TEST',               'True',                          '".MODULE_PAYMENT_PAYPAL_JA_EC_DESC_TEST."',               '6', '17', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");

    $query = "CREATE TABLE IF NOT EXISTS ".TABLE_PAYPAL_JA_LOG." (
                paypal_log_id int(11)      not null auto_increment,
                customers_id  int(11)      not null default 0,
                method        varchar(255) not null default '',
                request       text         not null default '',
                response      text         not null default '',
                ack           varchar(255) not null default '',
                created       datetime         null,
                updated       datetime         null,
                primary key(paypal_log_id)
              )";
    tep_db_query($query);

      tep_db_query("CREATE TABLE IF NOT EXISTS ".TABLE_PAYPAL_JA_SESSION." (" .
                   "paypal_session_id int(11) NOT NULL auto_increment," .
                   "random_id         varchar(64) binary NOT NULL," .
                   "session_data      blob NOT NULL," .
                   "expired           datetime default NULL," .
                   "PRIMARY KEY (paypal_session_id)," .
                   "INDEX (paypal_session_id,random_id)," .
                   "INDEX (expired)" .
                   ")");

      tep_db_query("CREATE TABLE IF NOT EXISTS ".TABLE_PAYPAL_JA_IPN_LOG." (" .
                   "paypal_ipn_log_id int(11) NOT NULL auto_increment," .
                   "post_data         text," .
                   "session_data      text," .
                   "comment           text," .
                   "created           datetime default NULL," .
                   "updated           datetime default NULL," .
                   "PRIMARY KEY (paypal_ipn_log_id)" .
                   ")");

      tep_db_query("CREATE TABLE IF NOT EXISTS ".TABLE_PAYPAL_JA_PAYMENT_STATUS_HISTORY." (" .
                   "payment_status_history_id int(11) NOT NULL auto_increment," .
                   "paypal_ipn_log_id         int(11) NOT NULL default '0'," .
                   "txn_id                    varchar(64) NOT NULL default ''," .
                   "parent_txn_id             varchar(64) NOT NULL default ''," .
                   "payment_status            varchar(17) NOT NULL default ''," .
                   "pending_reason            varchar(14) default NULL," .
                   "created                   datetime default NULL," .
                   "PRIMARY KEY (payment_status_history_id)," .
                   "INDEX (paypal_ipn_log_id)" .
                   ")");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array(
        'MODULE_PAYMENT_PAYPAL_JA_STATUS',
//        'MODULE_PAYMENT_PAYPAL_JA_ID',
//        'MODULE_PAYMENT_PAYPAL_JA_CURRENCY',
        'MODULE_PAYMENT_PAYPAL_JA_SETTLEMENT_TYPE',
        'MODULE_PAYMENT_PAYPAL_JA_ZONE',
        'MODULE_PAYMENT_PAYPAL_JA_UNCOMMIT_ORDER_STATUS_ID',
        'MODULE_PAYMENT_PAYPAL_JA_ORDER_STATUS_ID',
        'MODULE_PAYMENT_PAYPAL_JA_SORT_ORDER',

    'MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_ID',
    'MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_PASS',
    'MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_SIGNATURE',
    'MODULE_PAYMENT_PAYPAL_JA_EC_SETTLEMENT_TYPE',
    'MODULE_PAYMENT_PAYPAL_JA_EC_CURRENCY',
    'MODULE_PAYMENT_PAYPAL_JA_EC_TEST',


        'MODULE_PAYMENT_PAYPAL_JA_WPP_CURRENCY',
        'MODULE_PAYMENT_PAYPAL_JA_WPP_MERCHANT_ID',
        'MODULE_PAYMENT_PAYPAL_JA_WPP_SETTLEMENT_TYPE',
        'MODULE_PAYMENT_PAYPAL_JA_SELECT_MESSAGE',
        'MODULE_PAYMENT_PAYPAL_JA_PRE_ORDER_MESSAGE',
        'MODULE_PAYMENT_PAYPAL_JA_PAYPAL_TXN_ID',
        'MODULE_PAYMENT_PAYPAL_JA_WPP_EMAIL',
        'MODULE_PAYMENT_PAYPAL_JA_WPP_TEST',
        'MODULE_PAYMENT_PAYPAL_JA_WPP_IPN_TRACE_LOG',
        );
    }
  }
?>
