<?php
//define('PAYPAL_AUTH_MODE',       '3TOKEN');
define('PAYPAL_JA_EC_API_ENDPOINT_TEST', 'https://api-3t.sandbox.paypal.com/nvp');
define('PAYPAL_JA_EC_URL_TEST',          'https://www.sandbox.paypal.com/webscr&cmd=_express-checkout&token=');
define('PAYPAL_JA_EC_API_ENDPOINT',      'https://api-3t.paypal.com/nvp');
define('PAYPAL_JA_EC_URL',               'https://www.paypal.com/cgi-bin/webscr?cmd=_express-checkout&token=');
define('PAYPAL_JA_EC_VERSION',           '65.1');
define('PAYPAL_USE_PROXY',            FALSE);
define('PAYPAL_PROXY_HOST',           '127.0.0.1');
define('PAYPAL_PROXY_PORT',           '808');


class paypal_ja_express_checkout {

  var $code;

  var $title;

  var $description;

  var $sort_order;

  var $enabled;

  var $form_action_url;


  function paypal_ja_express_checkout($code, $title, $description, $sort_order, $enabled) {
    $this->code = $code;
    $this->title = $title;
    $this->description = $description;
    $this->sort_order = $sort_order;
    $this->enabled = $enabled;
    if ( ENABLE_SSL == 'true' ) {
      $this->form_action_url = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG . FILENAME_CHECKOUT_PROCESS;
    }
    else {
      $this->form_action_url = HTTP_SERVER . DIR_WS_CATALOG . FILENAME_CHECKOUT_PROCESS;
    }
  }

  function get_form_action_url() {
    return $this->form_action_url;
  }

  function update_status() {
  }

  function javascript_validation() {
    return false;
  }

  function selection() {
    return array('id' => $this->code,
                 'module' => $this->title);
  }

  function pre_confirmation_check() {
    return false;
  }

  function confirmation() {
    return false;
  }

  function process_button() {

    $process_button_string = '';

    return $process_button_string;
  }

  function before_process() {
    return false;
  }

  function after_process() {
    global $order, $order_total_modules;

    if (!isset($_REQUEST['token'])) {
      $this->SetExpressCheckout();
    }
    else {
      $this->DoExpressCheckout(urlencode($_REQUEST['token']));
    }
    return false;
  }

  function output_error() {
    return false;
  }

  function SetExpressCheckout() {
    global $order, $order_total_modules;
    global $currencies;

    $method = "SetExpressCheckout";

    $parm  = "";
    $parm .= "&RETURNURL=".urlencode(tep_href_link(FILENAME_CHECKOUT_PROCESS_PAYPAL_JA_EC, "", "SSL"));
    $parm .= "&CANCELURL=".urlencode(tep_href_link(FILENAME_CHECKOUT_PAYMENT, "", "SSL"));
    $parm .= "&REQCONFIRMSHIPPING=".(($order->content_type=="virtual")?"0":"1");
    $parm .= "&NOSHIPPING=".(($order->content_type=="virtual")?"1":"0");
    $parm .= "&LOCALECODE=".paypal_language_convert($_SESSION['language']);

    $parm .= "&PAYMENTREQUEST_0_SHIPTONAME=".paypal_esacpe_parm($order->delivery['firstname'].' '.$order->delivery['lastname']);
    $parm .= "&PAYMENTREQUEST_0_SHIPTOSTREET=".paypal_esacpe_parm($order->delivery['street_address']);
    $parm .= "&PAYMENTREQUEST_0_SHIPTOSTREET2=".paypal_esacpe_parm($order->delivery['suburb']);
    $parm .= "&PAYMENTREQUEST_0_SHIPTOCITY=".paypal_esacpe_parm($order->delivery['city']);
    $parm .= "&PAYMENTREQUEST_0_SHIPTOSTATE=".paypal_esacpe_parm($order->delivery['state']);
    $parm .= "&PAYMENTREQUEST_0_SHIPTOZIP=".paypal_esacpe_parm($order->delivery['postcode']);
    $parm .= "&PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE=".paypal_esacpe_parm($order->delivery['country']['iso_code_2']);
    $parm .= "&PAYMENTREQUEST_0_SHIPTOPHONENUM=".paypal_esacpe_parm($order->delivery['telephone']);

    if (MODULE_PAYMENT_PAYPAL_JA_EC_CURRENCY == 'USER') {
      $amt = paypal_ja_get_ot_total($order, $order_total_modules);
      $currency = $_SESSION['currency'];
    }
    else {
      $amt = paypal_ja_get_ot_total($order, $order_total_modules, false);
      $currency = MODULE_PAYMENT_PAYPAL_JA_EC_CURRENCY;
      $amt = number_format(paypal_ja_convert_money_string($amt) * $currencies->get_value($currency), $currencies->get_decimal_places($currency));
      $amt = paypal_ja_convert_money_string($amt);
    }

    $parm .= "&PAYMENTREQUEST_0_AMT=".$amt;
    $parm .= "&PAYMENTREQUEST_0_CURRENCYCODE=".paypal_esacpe_parm($currency);
    $parm .= "&PAYMENTREQUEST_0_PAYMENTACTION=".MODULE_PAYMENT_PAYPAL_JA_EC_SETTLEMENT_TYPE;

    $parm .= "&L_PAYMENTREQUEST_0_NAME0=".paypal_esacpe_parm(MODULE_PAYMENT_PAYPAL_TEXT_ITEMNAME);
    $parm .= "&L_PAYMENTREQUEST_0_AMT0=".$amt;
    $parm .= "&L_PAYMENTREQUEST_0_QTY0=1";

    $resArray = paypal_hash_call($method, $parm);
    $ack      = strtoupper($resArray["ACK"]);
    if ($ack == "SUCCESS") {
      // Redirect to paypal.com here
      $token     = urldecode($resArray["TOKEN"]);
      if (MODULE_PAYMENT_PAYPAL_JA_EC_TEST == 'True')
        $payPalURL = PAYPAL_JA_EC_URL_TEST.$token;
      else
        $payPalURL = PAYPAL_JA_EC_URL.$token;
      header("Location: ".$payPalURL);
      exit;
    }
    else {
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, "payment_error=paypal_ja&error_message=" . urlencode($resArray['L_LONGMESSAGE0']), "SSL"));
      exit;
    }
  }

  function get_error() {
    return $HTTP_GET_VAR['error_message'];
  }

  function DoExpressCheckout($token) {

    $method = "GetExpressCheckoutDetails";
    $parm   = "&TOKEN=".$token;

    $resArray = paypal_hash_call($method, $parm);
    $ack      = strtoupper($resArray["ACK"]);
    if ($ack != 'SUCCESS') {
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, "payment_error=paypal_ja&error_message=" . urlencode($resArray['L_LONGMESSAGE0']), "SSL"));
      exit;
    }

    if (MODULE_PAYMENT_PAYPAL_JA_EC_CURRENCY == 'USER') {
      $currency = $_SESSION['currency'];
    }
    else {
      $currency = MODULE_PAYMENT_PAYPAL_JA_EC_CURRENCY;
    }

    $method = "DoExpressCheckoutPayment";
    $parm   = "&TOKEN=".$token
            . "&PAYERID=".$resArray["PAYERID"]
            . "&PAYMENTREQUEST_0_PAYMENTACTION=".MODULE_PAYMENT_PAYPAL_JA_EC_SETTLEMENT_TYPE
            . "&PAYMENTREQUEST_0_AMT=".$resArray["PAYMENTREQUEST_0_AMT"]
            . "&PAYMENTREQUEST_0_CURRENCYCODE=".paypal_esacpe_parm($currency);
    $parm .= "&BUTTONSOURCE=FLATZ_Ecom_EC_JP";
    
    $resArray = paypal_hash_call($method, $parm);
    $ack      = strtoupper($resArray["ACK"]);
    if ($ack == 'SUCCESS' || $ack == 'SUCCESSWITHWARNING') {
    }
    else  {
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, "payment_error=paypal_ja&error_message=" . urlencode($resArray['L_LONGMESSAGE0']), "SSL"));
      exit;
    }
  }

}

?>
