<?php

  function paypal_ja_convert_money_string($value) {
    $str = "";
    for($i=0; $i<strlen($value); $i++) {
      if (substr($value, $i, 1) == "." ||
          substr($value, $i, 1) == "-" ||
          substr($value, $i, 1) >= "0" &&
          substr($value, $i, 1) <= "9")
        $str .= substr($value, $i, 1);
    }
    return (float)$str;
  }

  function paypal_ja_get_ot_total($order, $order_total_modules, $text=true) {
    $order_totals = $order_total_modules->process();

    $total = (int)$order->info['total'];
    foreach ($order_totals as $order_total) {
      if ($order_total['code'] == 'ot_total') {
        if ($text)
          return paypal_ja_convert_money_string($order_total['text']);
        else
          return (float)$order_total['value'];
      }
    }

    return $total;
  }

  function paypal_ja_get_ot_subtotal($order, $order_total_modules) {
    $order_totals = $order_total_modules->process();

    $total = (int)$order->info['subtotal'];
    foreach ($order_totals as $order_total) {
      if ($order_total['code'] == 'ot_subtotal') {
        return paypal_ja_convert_money_string($order_total['text']);
//        return (int)$order_total['value'];
      }
    }

    return $total;
  }

  function paypal_ja_get_ot_shipping($order, $order_total_modules) {
    $order_totals = $order_total_modules->process();

    $total = (int)$order->info['shipping_cost'];
    foreach ($order_totals as $order_total) {
      if ($order_total['code'] == 'ot_shipping') {
        return paypal_ja_convert_money_string($order_total['text']);
//        return (int)$order_total['value'];
      }
    }

    return $total;
  }

  function paypal_ja_get_ot_loworderfee($order, $order_total_modules) {
    $order_totals = $order_total_modules->process();

    $total = 0;
    foreach ($order_totals as $order_total) {
      if ($order_total['code'] == 'ot_loworderfee') {
        return paypal_ja_convert_money_string($order_total['text']);
//        return (int)$order_total['value'];
      }
    }

    return $total;
  }

  function paypal_ja_get_ot_tax($order, $order_total_modules) {
    $order_totals = $order_total_modules->process();

    $total = (int)$order->info['tax'];
    foreach ($order_totals as $order_total) {
      if ($order_total['code'] == 'ot_tax') {
        return paypal_ja_convert_money_string($order_total['text']);
//        return (int)$order_total['value'];
      }
    }

    return $total;
  }

  function paypal_ja_get_ot_coupon($order, $order_total_modules) {
    $order_totals = $order_total_modules->process();

    $total = 0;
    foreach ($order_totals as $order_total) {
      if ($order_total['code'] == 'ot_coupon') {
        return -paypal_ja_convert_money_string($order_total['text']);
//        return -(int)$order_total['value'];
      }
    }

    return $total;
  }

  function datetime_to_sql_format($paypalDateTime) {
    //Copyright (c) 2004 DevosC.com
    $months = array('Jan' => '01', 'Feb' => '02', 'Mar' => '03', 'Apr' => '04', 'May' => '05',  'Jun' => '06',  'Jul' => '07', 'Aug' => '08', 'Sep' => '09', 'Oct' => '10', 'Nov' => '11', 'Dec' => '12');
    $hour = substr($paypalDateTime, 0, 2);$minute = substr($paypalDateTime, 3, 2);$second = substr($paypalDateTime, 6, 2);
    $month = $months[substr($paypalDateTime, 9, 3)];
    $day = (strlen($day = preg_replace("/,/" , '' , substr($paypalDateTime, 13, 2))) < 2) ? '0'.$day: $day;
    $year = substr($paypalDateTime, -8, 4);
    if (strlen($day)<2) $day = '0'.$day;
    return ($year . "-" . $month . "-" . $day . " " . $hour . ":" . $minute . ":" . $second);
  }

  function ipn_debug_email($message, $email_address = MODULE_PAYMENT_PAYPAL_DEBUG_EMAIL_ADDRESS, $always_send = false) {
    if (MODULE_PAYMENT_PAYPAL_IPN_DEBUG == 'Yes' || $always_send) {
      mail($email_address,'IPN DEBUG message', $message);
      ipn_add_error_log($message);
    }
  }
  function ipn_add_error_log($message) {
    if (MODULE_PAYMENT_PAYPAL_TESTING == 'Test') {
//      echo date('D M Y G:i') . ' -- ' . $message . "\n";
    }
    $fp = @fopen('ipn.log', 'a');
    @fwrite($fp, date('D M Y G:i') . ' -- ' . $message . "\n");
    @fclose($fp);
  }
  function ipn_fopen($filename) {
    $response = '';
    $fp = fopen($filename,'rb');
    if ($fp) {
      $response = getRequestBodyContents($fp);
      @fclose($fp);
    }
    return $response;
  }
  function getRequestBodyContents(&$handle) {
    if ($handle) {
      while(!feof($handle)) {
        $line .= @fgets($handle, 1024);
      }
      return $line;
    }
    return false;
  }

  function paypal_language_convert($name) {
    if (strtolower($name) == "english")  return "US";
    if (strtolower($name) == "japanese") return "JP";
    return "US";
  }

  function paypal_esacpe_parm($parm) {
    $parm = mb_convert_encoding($parm, "UTF-8", CHARSET);
    $parm = urlencode($parm);
//    $parm = htmlspecialchars($parm);
    return $parm;
  }

  function paypal_nvpHeader($methodName) {
    $nvpHeaderStr = "";
    if (defined('PAYPAL_AUTH_MODE')) {
      //$AuthMode = "3TOKEN"; //Merchant's API 3-TOKEN Credential is required to make API Call.
      //$AuthMode = "FIRSTPARTY"; //Only merchant Email is required to make EC Calls.
      //$AuthMode = "THIRDPARTY";Partner's API Credential and Merchant Email as Subject are required.
      $AuthMode = PAYPAL_AUTH_MODE;
    }
    else {
      $AuthMode = "3TOKEN";
    }

    switch($AuthMode) {
      case "3TOKEN":
        $nvpHeaderStr = "&PWD=".urlencode(MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_PASS)."&USER=".urlencode(MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_ID)."&SIGNATURE=".urlencode(MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_SIGNATURE);
        break;
      case "FIRSTPARTY":
        $nvpHeaderStr = "&SUBJECT=".urlencode($subject);
        break;
      case "THIRDPARTY":
        $nvpHeaderStr = "&PWD=".urlencode(MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_PASS)."&USER=".urlencode(MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_ID)."&SIGNATURE=".urlencode(MODULE_PAYMENT_PAYPAL_JA_EC_BUSINESS_SIGNATURE)."&SUBJECT=".urlencode($subject);
        break;    
      case "PERMISSION":
        $nvpHeaderStr = formAutorization($AUTH_token,$AUTH_signature,$AUTH_timestamp);
        break;
    }
    return $nvpHeaderStr;
  }

  function paypal_hash_call($methodName, $nvpStr) {
    // form header string
    $nvpheader = paypal_nvpHeader($methodName);

    //setting the curl parameters.
    $ch = curl_init();
    if (MODULE_PAYMENT_PAYPAL_JA_EC_TEST == 'True')
      curl_setopt($ch, CURLOPT_URL, PAYPAL_JA_EC_API_ENDPOINT_TEST);
    else
      curl_setopt($ch, CURLOPT_URL, PAYPAL_JA_EC_API_ENDPOINT);
    curl_setopt($ch, CURLOPT_VERBOSE, 1);

    //turning off the server and peer verification(TrustManager Concept).
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);

    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_POST, 1);

    //in case of permission APIs send headers as HTTPheders
//    if(!empty($AUTH_token) && !empty($AUTH_signature) && !empty($AUTH_timestamp)) {
//      $headers_array[] = "X-PP-AUTHORIZATION: ".$nvpheader;
//      curl_setopt($ch, CURLOPT_HTTPHEADER, $headers_array);
//      curl_setopt($ch, CURLOPT_HEADER, false);
//    }
//    else {
      $nvpStr=$nvpheader.$nvpStr;
//    }

    //if USE_PROXY constant set to TRUE in Constants.php, then only proxy will be enabled.
    //Set proxy name to PROXY_HOST and port number to PROXY_PORT in constants.php 
    if (PAYPAL_USE_PROXY)
      curl_setopt ($ch, CURLOPT_PROXY, PAYPAL_PROXY_HOST.":".PAYPAL_PROXY_PORT); 

    //check if version is included in $nvpStr else include the version.
    if(strlen(str_replace('VERSION=', '', strtoupper($nvpStr))) == strlen($nvpStr)) {
      $nvpStr = "&VERSION=" . urlencode(PAYPAL_JA_EC_VERSION) . $nvpStr;
    }

    $nvpreq="METHOD=".urlencode($methodName).$nvpStr;

    //setting the nvpreq as POST FIELD to curl
    curl_setopt($ch, CURLOPT_POSTFIELDS, $nvpreq);

    //getting response from server
    $id       = paypal_create_log($_SESSION['customer_id'], $methodName, $nvpreq);
    $response = curl_exec($ch);
    paypal_update_log($id, $response);

    //convrting NVPResponse to an Associative Array
    $nvpResArray             = paypal_deformatNVP($response);
    $nvpReqArray             = paypal_deformatNVP($nvpreq);

    if (curl_errno($ch)) {
      $nvpResArray['ACK']            = "ERROR";
      $nvpResArray['L_LONGMESSAGE0'] = curl_error($ch)."[".curl_errno($ch)."]";
    }
    curl_close($ch);

    return $nvpResArray;
  }

  function paypal_deformatNVP($nvpstr) {
  	$intial=0;
   	$nvpArray = array();


  	while(strlen($nvpstr)) {
  		//postion of Key
  		$keypos= strpos($nvpstr,'=');
  		//position of value
  		$valuepos = strpos($nvpstr,'&') ? strpos($nvpstr,'&'): strlen($nvpstr);

  		/*getting the Key and Value values and storing in a Associative Array*/
  		$keyval=substr($nvpstr,$intial,$keypos);
  		$valval=substr($nvpstr,$keypos+1,$valuepos-$keypos-1);
  		//decoding the respose
  		$nvpArray[urldecode($keyval)] =urldecode( $valval);
  		$nvpstr=substr($nvpstr,$valuepos+1,strlen($nvpstr));
    }
  	return $nvpArray;
  }

  function paypal_create_log($customers_id, $method, $request) {

    $query = "insert into ".TABLE_PAYPAL_JA_LOG." (customers_id, method, request, created) values(".(int)$customers_id.", '".tep_db_input($method)."', '".tep_db_input($request)."', now())";
    tep_db_query($query);

    return tep_db_insert_id();
  }

  function paypal_update_log($paypal_log_id, $response) {

    $nvpResArray = paypal_deformatNVP($response);
    $query       = "update ".TABLE_PAYPAL_JA_LOG." set response='".tep_db_input($response)."',ack='".tep_db_input($nvpResArray['ACK'])."',updated=now() where paypal_log_id=".(int)$paypal_log_id;
    tep_db_query($query);
  }

  function paypal_get_default_currency() {
    global $currencies;

    foreach($currencies->currencies as $k => $c) {
      if ($c['value'] == 1)
        return $k;
    }

    return "";
  }
 

?>
