<?php

class paypal_ja_web_payment_plus {

  var $code;

  var $title;

  var $description;

  var $sort_order;

  var $enabled;

  var $form_action_url;


  function paypal_ja_web_payment_plus($code, $title, $description, $sort_order, $enabled) {
    $this->code = $code;
    $this->title = $title;
    $this->description = $description;
    $this->sort_order = $sort_order;
    $this->enabled = $enabled;
    if ( ENABLE_SSL == 'true' ) {
      $this->form_action_url = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG . FILENAME_CHECKOUT_PROCESS_PAYPAL_JA_WPP;
    }
    else {
      $this->form_action_url = HTTP_SERVER . DIR_WS_CATALOG . FILENAME_CHECKOUT_PROCESS_PAYPAL_JA_WPP;
    }
  }

  function get_form_action_url() {
    return $this->form_action_url;
  }

  function update_status() {
  }

  function javascript_validation() {
    return false;
  }

  function selection() {
    return array('id' => $this->code,
                 'module' => $this->title,
                 'fields' => array(array('title' => MODULE_PAYMENT_PAYPAL_JA_SELECT_MESSAGE,
                                         'field' => '')));
  }

  function pre_confirmation_check() {
    return false;
  }

  function confirmation() {
    return false;
  }

  function process_button() {
    global $order, $currencies, $currency, $order_total_modules;

    if (MODULE_PAYMENT_PAYPAL_JA_WPP_CURRENCY == 'User Selected Currency') {
      $amt = paypal_ja_get_ot_total($order, $order_total_modules);
      $currency = $_SESSION['currency'];
    }
    else {
      $amt = paypal_ja_get_ot_total($order, $order_total_modules, false);
      $currency = MODULE_PAYMENT_PAYPAL_JA_WPP_CURRENCY;
      $amt = number_format(paypal_ja_convert_money_string($amt) * $currencies->get_value($currency), $currencies->get_decimal_places($currency));
      $amt = paypal_ja_convert_money_string($amt);
    }

    $_SESSION['paypal_subtotal'] = $amt;
    $_SESSION['paypal_currency'] = $currency;
    $_SESSION['paypal_comments'] = $order->info['comments'];

    $billing_country = '';
    if ( strcasecmp($order->billing['country']['title'], 'Japan') === 0 ) {
      $billing_country = 'JP';
    }

    $delivery_country = '';
    if ( strcasecmp($order->delivery['country']['title'], 'Japan') === 0 ) {
      $delivery_country = 'JP';
    }

    $customers_query = tep_db_query("SELECT customers_telephone FROM " . TABLE_CUSTOMERS .
                                    " WHERE customers_id='" . tep_db_input($_SESSION['customer_id']) . "'");
    $result = tep_db_fetch_array($customers_query);
    $customers_telephone = $result['customers_telephone'];

    $paypal_submitter_params['business'] = MODULE_PAYMENT_PAYPAL_JA_WPP_MERCHANT_ID;
    $paypal_submitter_params['subtotal'] = $amt;
    $paypal_submitter_params['currency_code'] = $currency;
    $paypal_submitter_params['buyer_email'] = $order->customer['email_address'];
    $paypal_submitter_params['billing_country'] = $billing_country;
    $paypal_submitter_params['billing_zip'] = str_replace('-', '', $order->billing['postcode']);
    $paypal_submitter_params['billing_state'] = $order->billing['state'];
    $paypal_submitter_params['billing_city'] = $order->billing['city'];
    $paypal_submitter_params['billing_address1'] = $order->billing['street_address'];
    $paypal_submitter_params['billing_address2'] = $order->billing['suburb'];
    $paypal_submitter_params['billing_last_name'] = $order->billing['lastname'];
    $paypal_submitter_params['billing_first_name'] = $order->billing['firstname'];
    $paypal_submitter_params['country'] = $delivery_country;
    $paypal_submitter_params['zip'] = str_replace('-', '', $order->delivery['postcode']);
    $paypal_submitter_params['state'] = $order->delivery['state'];
    $paypal_submitter_params['city'] = $order->delivery['city'];
    $paypal_submitter_params['address1'] = $order->delivery['street_address'];
    $paypal_submitter_params['address2'] = $order->delivery['suburb'];
    $paypal_submitter_params['last_name'] = $order->delivery['lastname'];
    $paypal_submitter_params['first_name'] = $order->delivery['firstname'];
    $paypal_submitter_params['night_phone_b'] = $customers_telephone;
    $paypal_submitter_params['return'] = tep_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL');
    $paypal_submitter_params['paymentaction'] = MODULE_PAYMENT_PAYPAL_JA_WPP_SETTLEMENT_TYPE;
    $paypal_submitter_params['cancel_return'] = tep_href_link(FILENAME_CHECKOUT_CONFIRMATION, '', 'SSL');
    $paypal_submitter_params['bn'] = 'FLATZ_Ecom_EC_JP';
    $_SESSION['paypal_submitter_params'] = $paypal_submitter_params;

    $process_button_string = '';

    return $process_button_string;
  }

  function before_process() {
    return false;
  }

  function after_process() {
    return false;
  }

  function output_error() {
    return false;
  }

  function get_error() {
    return false;
  }

}

?>
