<?php

require_once('includes/modules/payment/paypal_ja/paypal_ja_definition.php');
require('includes/application_top.php');

paypal_trace_log('===== IPN Message process begin. =====');
paypal_process_message();
paypal_trace_log('===== IPN Message process end. =====');

function paypal_process_message() {
  // check client ip.
  $hostName = strtolower(gethostbyaddr($_SERVER['REMOTE_ADDR']));
  if ( MODULE_PAYMENT_PAYPAL_JA_WPP_TEST == 'True' ) {
    $ipnHostName = 'ipn.sandbox.paypal.com';
  }
  else {
    $ipnHostName = 'notify.paypal.com';
  }
  $clientCheckOK = ($hostName == $ipnHostName) ? TRUE : FALSE;
  if ( !$clientCheckOK ) {
    paypal_trace_log('Invalid client. ip=' . $_SERVER['REMOTE_ADDR'] . ',hostname=' . $hostName . ',expect=' . $ipnHostName);
    return;
  }

  global $paypal_ipn_log_id;
  tep_db_query("INSERT INTO " . TABLE_PAYPAL_JA_IPN_LOG . " (post_data,created,updated)" .
               " VALUES('".tep_db_input(var_export($_POST, TRUE))."',now(),now())");
  $paypal_ipn_log_id = tep_db_insert_id();
  paypal_trace_log(TABLE_PAYPAL_JA_IPN_LOG . ' inserted. paypal_ipn_log_id=' . $paypal_ipn_log_id);

  $response = paypal_ipn_response();

  $parsed_custom = explode('-', $_POST['custom']);
  if (count($parsed_custom) != 2) {
    paypal_write_ipn_log('Invalid POST value. custom=' . $_POST['custom']);
    return;
  }
  $paypal_session_id = $parsed_custom[0];
  $random_id = $parsed_custom[1];

  $paypal_session_query = tep_db_query("SELECT session_data FROM " . TABLE_PAYPAL_JA_SESSION .
                                       " WHERE paypal_session_id='" . tep_db_input($paypal_session_id) . "' AND random_id='" . tep_db_input($random_id) . "'");
  $paypal_session_query_num_rows = tep_db_num_rows($paypal_session_query);
  if (empty($paypal_session_query_num_rows)) {
    paypal_write_ipn_log('Record not found. table=' . TABLE_PAYPAL_JA_SESSION . ',paypal_session_id=' . $paypal_session_id . ',random_id=' . $random_id);
    return;
  }
  $result = tep_db_fetch_array($paypal_session_query);
  $_SESSION = unserialize(base64_decode($result['session_data']));
  if ($_SESSION === FALSE) {
    paypal_write_ipn_log('Session restore failed. table=' . TABLE_PAYPAL_JA_SESSION . ',paypal_session_id=' . $paypal_session_id . ',random_id=' . $random_id);
    return;
  }
  paypal_trace_log(TABLE_PAYPAL_JA_SESSION . ' found. paypal_session_id=' . $paypal_session_id . ',random_id=' . $random_id);

  $session_data = 'order_id=' . $_SESSION['paypal_order_id'] .
                  ',subtotal=' . $_SESSION['paypal_subtotal'] .
                  ',currency=' . $_SESSION['paypal_currency'] .
                  ',comment=' . $_SESSION['paypal_comments'];
  tep_db_query("UPDATE " . TABLE_PAYPAL_JA_IPN_LOG . " SET" .
               " session_data='" . tep_db_input($session_data) . "'" .
               ",updated=now()" .
               " WHERE paypal_ipn_log_id='" . tep_db_input($paypal_ipn_log_id) . "'");

  if (paypal_ipn_check($response)) {
    $new_status = MODULE_PAYMENT_PAYPAL_JA_ORDER_STATUS_ID ? MODULE_PAYMENT_PAYPAL_JA_ORDER_STATUS_ID : DEFAULT_ORDERS_STATUS_ID;

    $order_query = tep_db_query("SELECT orders_id FROM " . TABLE_ORDERS .
                                       " WHERE orders_id='" . tep_db_input($_SESSION['paypal_order_id']) . "'");
    $order_query_num_rows = tep_db_num_rows($order_query);
    if (empty($order_query_num_rows)) {
      paypal_write_ipn_log_and_mail('Record not found. table=' . TABLE_ORDERS . ',orders_id=' . $_SESSION['paypal_order_id']);
    }
    else {
      tep_db_query("UPDATE " . TABLE_ORDERS . " SET orders_status='" . tep_db_input($new_status) . "'" .
                   " WHERE orders_id='" . tep_db_input($_SESSION['paypal_order_id']) . "'");
      paypal_trace_log(TABLE_ORDERS . ' updated. orders_id=' . $_SESSION['paypal_order_id']);

      $newline = (strlen($_SESSION['paypal_comments']) > 0) ? "\n\n" : "";
      $comment = $_SESSION['paypal_comments'] . $newline . MODULE_PAYMENT_PAYPAL_JA_PAYPAL_TXN_ID . ' ' . $_POST['txn_id'];

      tep_db_query("INSERT INTO " . TABLE_ORDERS_STATUS_HISTORY .
                   "(orders_id" .
                   ",orders_status_id" .
                   ",date_added" .
                   ",comments" .
                   ") VALUES (" .
                   "'" . tep_db_input($_SESSION['paypal_order_id']) . "'," .
                   "'" . tep_db_input($new_status) . "'," .
                   "now()," .
                   "'" . tep_db_input($comment) . "')");
      paypal_trace_log(TABLE_ORDERS_STATUS_HISTORY . ' inserted. orders_status_history_id=' . tep_db_insert_id());
    }

    tep_db_query("DELETE FROM " . TABLE_PAYPAL_JA_SESSION .
                 " WHERE paypal_session_id='" . tep_db_input($paypal_session_id) . "' AND random_id='" . tep_db_input($random_id) . "'");
    paypal_trace_log(TABLE_PAYPAL_JA_SESSION . ' deleted. paypal_session_id=' . $paypal_session_id . ',random_id=' . $random_id);
  }

  tep_db_query("INSERT INTO " . TABLE_PAYPAL_JA_PAYMENT_STATUS_HISTORY . " " .
               "(paypal_ipn_log_id" .
               ",txn_id" .
               ",parent_txn_id" .
               ",payment_status" .
               ",pending_reason" .
               ",created" .
               " ) VALUES (" .
               "'" . tep_db_input($paypal_ipn_log_id) . "'," .
               "'" . tep_db_input($_POST['txn_id']) . "'," .
               "'" . tep_db_input($_POST['parent_txn_id']) . "'," .
               "'" . tep_db_input($_POST['payment_status']) . "'," .
               "'" . tep_db_input($_POST['pending_reason']) . "'," .
               "now())");
  paypal_trace_log(TABLE_PAYPAL_JA_PAYMENT_STATUS_HISTORY . ' inserted. payment_status_history_id=' . tep_db_insert_id());
}


function paypal_ipn_response() {

  if ( MODULE_PAYMENT_PAYPAL_JA_WPP_TEST == 'True' ) {
    $paypalHostName = 'www.sandbox.paypal.com';
  }
  else {
    $paypalHostName = 'www.paypal.com';
  }
  $paypal_webscr_url = 'https://'.$paypalHostName.'/cgi-bin/webscr';

  $req = 'cmd=' . rawurlencode('_notify-validate');

  foreach ($_POST as $key => $value) {
    $value = rawurlencode(mb_convert_encoding($value, $_POST['charset']));
    $req .= "&$key=$value";
  }

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $paypal_webscr_url);
  curl_setopt($ch, CURLOPT_HEADER, FALSE);
  curl_setopt($ch, CURLOPT_POST, TRUE);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, TRUE);
  curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
  curl_setopt($ch, CURLOPT_HTTPHEADER, array('Host: ' . $paypalHostName));
  curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
  $res = curl_exec($ch);
  $status_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
  paypal_trace_log('call PayPal. url=' . $paypal_webscr_url . ',statuscode=' . $status_code . ',res=' . $res);
  curl_close($ch);

  return array('url' => $paypal_webscr_url, 'status_code' => $status_code, 'res' => $res);
}


function paypal_ipn_check($response) {

  if ($response['status_code'] != 200) {
    paypal_write_ipn_log_and_mail('url=' . $response['url'] . ',statuscode=' . $response['status_code'] . ',res=' . $response['res']);
    return FALSE;
  }

  if ($response['res'] != 'VERIFIED') {
    // log for manual investigation
    paypal_write_ipn_log_and_mail('url=' . $response['url'] . ',statuscode=' . $response['status_code'] . ',res=' . $response['res']);
    return FALSE;
  }

  if (($_POST['payment_status'] == 'Completed') ||
      ($_POST['payment_status'] == 'Pending')) {
    // check that txn_id has not been previously processed
    // processed transaction session is deleted, then do not need to check txn_id.

    // check that receiver_email is your Primary PayPal email

    // check that payment_amount are correct
    if ($_POST['mc_gross'] != $_SESSION['paypal_subtotal']) {
      paypal_write_ipn_log_and_mail('mc_gross differ. expect=' . $_SESSION['paypal_subtotal'] . ', actual=' . $_POST['mc_gross']);
      return FALSE;
    }

    // check that payment_currency are correct
    if ($_POST['mc_currency'] != $_SESSION['paypal_currency']) {
      paypal_write_ipn_log_and_mail('mc_currency differ. expect=' . $_SESSION['paypal_currency'] . ', actual=' . $_POST['mc_currency']);
      return FALSE;
    }

    // OK
    paypal_trace_log('IPN message check ok.');
    return TRUE;
  }

  paypal_write_ipn_log_and_mail('UnExpected payment_status. payment_status=' . $_POST['payment_status']);
  return FALSE;
}


function paypal_write_ipn_log_and_mail($comment) {
  paypal_write_ipn_log($comment);
  if (strlen(MODULE_PAYMENT_PAYPAL_JA_WPP_EMAIL) > 0) {
    mail(MODULE_PAYMENT_PAYPAL_JA_WPP_EMAIL,
      'IPN Error Message',
      'paypal_ipn_log_id=' . $paypal_ipn_log_id . "\r\n" . $comment);
  }
}

function paypal_write_ipn_log($comment) {
  global $paypal_ipn_log_id;
  tep_db_query("UPDATE " . TABLE_PAYPAL_JA_IPN_LOG . " SET" .
               " comment='".tep_db_input($comment)."'" .
               ",updated=now()" .
               " WHERE paypal_ipn_log_id='" . tep_db_input($paypal_ipn_log_id) . "'");
  paypal_trace_log($comment);
}


function paypal_trace_log($message) {
  if (MODULE_PAYMENT_PAYPAL_JA_WPP_IPN_TRACE_LOG != 'True') {
    return;
  }
  $fp = fopen('/tmp/paypal_trace_log.' . date('Ymd'), 'a');
  if ($fp === FALSE) {
    return;
  }
  if (flock($fp, LOCK_EX)) {
    fwrite($fp, date('Y-m-d H:i:s', mktime()) . ' ' . getmypid() . ' ' . $message . "\n");
    flock($fp, LOCK_UN);
  }
  fclose($fp);
}

?>
